#pragma once

#include "envoy/common/random_generator.h"

namespace Envoy {
namespace Random {
/**
 * Implementation of RandomGenerator that uses per-thread RANLUX generators seeded with current
 * time.
 */
class RandomGeneratorImpl : public RandomGenerator {
public:
  // Random::RandomGenerator
  uint64_t random() override;
  std::string uuid() override;

  static const size_t UUID_LENGTH;
};

} // namespace Random
} // namespace Envoy
